Goose Architecture Decisions
==========

Vision & Philosophy
----------

- **Reliable**: Code/Hardware/Network failure shouldn't cause Job/Data loss
- Cloud-native Architecture
    - Deployments shouldn't cause downtime
- Pluggable
- Multi-broker
- Scalable
- Concurrency-friendly
- Configurable, *with sane defaults*
- Auditable/Queryable (WRT job management & performance tracking)

Index
----------

1. [Pluggable Message Brokers](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/pluggable-message-brokers.md)
1. [Interface](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/interface.md)
1. [Enqueue-Dequeue](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/enqueue-dequeue.md)
1. [Priority/Customized Queues](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/priority-queues.md)
1. [Scheduled Jobs](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/scheduled-jobs.md)
1. [Periodic Jobs](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/periodic-jobs.md)
1. [Error-handling & Retrying](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/error-handling.md)
1. [API](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/api.md)
1. [Reliability](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/reliability.md)
1. [RabbitMQ](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/rabbitmq.md)
1. [Redis](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/redis.md)
1. [Metrics](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/metrics.md)
1. [Specs](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/specs.md)
1. [Logging](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/logging.md)
1. [Wiki / Documentation](https://github.com/nilenso/goose/blob/main/architecture-decisions/pages/wiki.md)
